//----------------------------------------------
// PYRAMID -- Double precision version
//----------------------------------------------
// Copyright (C) 1993, Nicholas Centanni
//----------------------------------------------
#ifndef __OP_SCENE_H
#include <op_scene.h>
#endif

#define BASE_SIZE    200
#define PYR_HEIGHT   300

extern d_point pyramid_vertices[];
extern d_surface pyramid_surfaces[];

class d_Pyramid : public d_Object
{
 private:
  i_point b_box[2];               // Bounding box for fast erase process
  i_point st_box[2];              // Initializer for the bounding box
  void bounding_box(void);        // Calculate the current bounding box
  int shade_offset;               // To use diff shades for cloned objs

 public:
   d_Pyramid(d_Environ *env);
   ~d_Pyramid(void) {}
   void draw(int state, int method, int in_window);
   d_Pyramid *clone(d_Environ *env);
   void offset_shades(int offset);
};
