//----------------------------------------------
// STAR -- Double Precision version
//----------------------------------------------
// Copyright (C) 1993, Nicholas Centanni
//----------------------------------------------
#include <graphics.h>
#include <opus.h>
#include <op_view.h>
#include <op_color.h>
#include <op_scene.h>
#include "d_star.h"

d_point star_position = { 400, 300, 0 };

//------------------------------------------------------------------------
// OBJECT constructor
//------------------------------------------------------------------------
d_Star::d_Star(d_Environ *env) : d_Object(env)
{
  read_vertices(&star_position, 1);
  set_draw_method(POINTS);
}

//------------------------------------------------------------------------
// OBJECT drawing methods
//------------------------------------------------------------------------
void d_Star::draw(int state, int, int in_window)
{
  int size = sizeof(i_screen);
  char *p = pixels + (size * in_window) + (size * graphics->active_page);
  i_screen *pixel = (i_screen *)p;
  int color = state == ON ? WHITE : 0;

  if (pixel->visible)
    plot_5(pixel->x, pixel->y, color, color);
}
