//----------------------------------------------
// STAR -- Double Precision version
//----------------------------------------------
// Copyright (C) 1993, Nicholas Centanni
//----------------------------------------------
#include <graphics.h>
#include <opus.h>
#include <op_view.h>
#include <op_color.h>
#include <op_scene.h>
#include "f_star.h"

f_point star_position = { I2F(400), I2F(300), I2F(0) };

//------------------------------------------------------------------------
// f_Star constructor
//------------------------------------------------------------------------
f_Star::f_Star(f_Environ *env) : f_Object(env)
{
  read_vertices(&star_position, 1);
  set_draw_method(POINTS);
}

//------------------------------------------------------------------------
// f_Star drawing methods
//------------------------------------------------------------------------
void f_Star::draw(int state, int, int in_window)
{
  int size = sizeof(i_screen);
  char *p = pixels + (size * in_window) + (size * graphics->active_page);
  i_screen *pixel = (i_screen *)p;
  int color = state == ON ? WHITE : 0;

  if (pixel->visible)
    plot_5(pixel->x, pixel->y, color, color);
}
