//----------------------------------------------
// EG_PANEL -- XYZ++ example program
//----------------------------------------------
// EGA control panel header
//----------------------------------------------
// Copyright (C) 1993, Nicholas Centanni
//----------------------------------------------

//
// Declare a custom panel class derived from the
// base library Panel class
//
#define BTN_MAX      4
#define LED_MAX      2
#define RADIO_MAX    0
#define PROMPT_MAX   1
class EGAPanel : public Panel
{
 public:
  EGAPanel(Graphics *g, Mouse *m, Keyboard *k) :
           Panel(g, m, k, NULLP, BTN_MAX, LED_MAX, RADIO_MAX, PROMPT_MAX) {}
  void define(void);
  void display(void);
  long key_read(void);
};

//
// Give descriptive name to the colors
// in our custom palette
//
#define EG_BLACK        0
#define EG_BROWN        1
#define EG_RED          2
#define EG_ORANGE       3
#define EG_DK_YELLOW    4
#define EG_LT_YELLOW    5
#define EG_LT_GREEN     6
#define EG_DK_GREEN     7
#define EG_CYAN         8
#define EG_BLUE         9
#define EG_DK_MAGENTA  10
#define EG_LT_MAGENTA  11
#define EG_LT_RED      12
#define EG_LT_GRAY     13
#define EG_DK_GRAY     14
#define EG_WHITE       15

//
// Panel EVENT/CONTROLS
//
#define UP_BTN          0
#define DN_BTN          1
#define QUIT_BTN        2
#define RESET_BTN       3

#define LED_1           0
#define LED_2           1

extern Graphics graphics;
extern int x, y;
extern int width, height;
extern long led_val1;
extern double led_val2;
extern palettetype pal;
extern char u_up[];
extern char u_dn[];
extern char d_up[];
extern char d_dn[];
extern char led_map1[];
extern char led_map2[];
extern char light_on[];
extern char light_off[];
extern char prompt_str[];
