//----------------------------------------------
// POINT -- XYZ++ example program
//----------------------------------------------
// Minimal code required to draw a single
// point in 3D space
//----------------------------------------------
// Copyright (C) 1993, Nicholas Centanni
//----------------------------------------------
#include <graphics.h>
#include <conio.h>
#include <op_view.h>
#include <op_graph.h>

l_point point = { 20L, 20L, 20L };   // Define a point in space
i_screen pixel;                      // Destination screen point

Viewer viewer;      // Declare an instance of the 3D Viewer class
Graphics graphics;  // Declare an instance of the BGI support class

void main()
{
  registerbgidriver(EGAVGA_driver);
  graphics.on(EGA, EGAHI, "");               // Start graphics mode
  graphics.define_port(0, 0, 0, 640, 350);   // Define a view rectangle
  graphics.set_port(0);                      // Assign object to a port

  viewer.set_position(100, 100, 100);  // Define viewer's vantage point
  viewer.set_zoom(15);                 // Set viewing magnification
  viewer.set_center(20, 20, 20);       // Declare the scene center 
  viewer.view_center();                // Aim the viewer towards the center
  viewer.new_view();                   // Let system know the view has changed

  viewer.translate(&point, &pixel);    // Calculate point's screen position
  putpixel(pixel.x, pixel.y, WHITE);   // Plot the resulting point

  getch();                             // Wait for a keypress
  graphics.off();                      // Return to text mode
}

