//------------------------------------------------------------------------
// Star field animation -- XYZ++ sample application
//------------------------------------------------------------------------
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include "sp_ver.h"

Viewer viewer;
Space space;
int old_mode;
Graphics graphics;  // Declare an instance of the BGI support class

//--------------------------------------------------------------------------
// Program MAIN
//--------------------------------------------------------------------------
void main()
{
  // Bail out now if there was not enough memory for the starfield
  if (space.stars == 0L)
  {
    printf("Not enough memory to continue.\n");
    exit(0);
  }

  registerbgidriver(EGAVGA_driver);
  graphics.on(VGA, VGAMED, "");                // Start graphics mode
  graphics.define_port(0, 0, 0, 
                       getmaxx(), getmaxy());  // Define a view rectangle
  graphics.set_port(0);                        // Assign object to a port
  graphics.paging_on();                        // Enable page-flipping

  viewer.set_zoom(60);
  viewer.set_position(0, 0, 0);
  viewer.set_center(0, 0, -2000);
  viewer.view_center();
  viewer.new_view();

  // Draw the starfield on both pages
  graphics.chg_active_page();
  space.draw(ON);
  graphics.chg_active_page();
  space.draw(ON);

  while (!kbhit())
  {
    // Draw the starfield on the active page
    graphics.chg_active_page();
    space.draw(OFF);
    space.move(20);
    space.draw(ON);
    graphics.chg_visual_page();

    delay(20);
  }

  getch();
  graphics.off();
}

//--------------------------------------------------------------------------
// Exit the program if the host system is inadequate
//--------------------------------------------------------------------------
void bail(int cause)
{
  closegraph();

  if (cause == MEM_ERR)
    printf("Not enough memory to run.\n");
  else if (cause == BGI_ERR)
    printf("Could not start BGI graphics mode.\n");

  exit(-1);
}
