//--------------------------------------------------
// BIOS timer functions
//--------------------------------------------------
// Replaces the Borland 3.1 Timer class no longer
// supported in version 4.0
//--------------------------------------------------
#ifndef __OP_TIMER_H
#define __OP_TIMER_H
#include <bios.h>

class BIOS_Timer
{
 private:
  long st_time, en_time;

 public:
  BIOS_Timer() : st_time(0L), en_time(0L) {}
  ~BIOS_Timer() {}
  void reset() { st_time = en_time; }
  void start() { st_time = biostime(0, 0L); }
  void stop() { en_time = biostime(0, 0L); }
  double time() { return (double)(en_time - st_time) / 18.2; }
};

#endif

