//----------------------------------------------------------------
// Vector Mathematics Class for fixed and floating point 
//----------------------------------------------------------------
#ifndef __OP_VECT_H
#define __OP_VECT_H
#ifndef __OP_TYPES_H
#include <op_types.h>
#endif

//--------------------------------------------------------------------------
// Vector Mathematics Class
//--------------------------------------------------------------------------
class Vect
{
 public:
  Vect() {};
  ~Vect() {};

  //----------------------------------
  // Floating point member functions
  //----------------------------------
  double magnitude(d_point *v);
  d_point sub(d_point *v1, d_point *v2);
  d_point add(d_point *v1, d_point *v2);
  d_point div(d_point *v1, double num);
  d_point cross(d_point *v1, d_point *v2);
  void normalize(d_point *v1);
  double dot(d_point *v1, d_point *v2);
  d_point intersect(d_line line, d_plane *plane); 
  d_point intersect(d_point *p1, d_point *p2, d_point *normal);          

  //----------------------------------
  // Fixed point member functions
  //----------------------------------
  fixed magnitude(f_point *v);
  f_point sub(f_point *v1, f_point *v2);
  f_point add(f_point *v1, f_point *v2);
  f_point div(f_point *v1, fixed num);
  f_point cross(f_point *v1, f_point *v2);
  void normalize(f_point *v1);
  fixed dot(f_point *v1, f_point *v2);
  f_point intersect(f_line line, f_plane *plane); 
  f_point intersect(f_point *p1, f_point *p2, f_point *normal);          
};
#endif
